window.Gleam.initSearch([{"doc":"espresso_pgo_wrapper","title":"espresso_pgo_wrapper","content":"# espresso_pgo_wrapper\n\n[![Package Version](https://img.shields.io/hexpm/v/espresso_pgo_wrapper)](https://hex.pm/packages/espresso_pgo_wrapper)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/espresso_pgo_wrapper/)\n\nSimple wrapper around gleam/pgo that does some very naive query building. Not inteded for use in\nany real world applications.\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add espresso_pgo_wrapper\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/espresso_pgo_wrapper&gt;.\n","url":"index.html"},{"doc":"database/schema","title":"Field","content":"pub type Field {\n  Field(name: String, type_: FieldType)\n}\n A field in a table. The name is used to\n generate SQL queries. Eventually would like to figure\n out a way to autogenerate the decoder based on these.\n \n Right now only integer and string fields are supported but these\n could really be anything that can be represented in PGO.\nField(name: String, type_: FieldType)\n\n\nSynonyms:\ndatabase/schema.Field\ndatabase/schema Field","url":"database/schema.html#Field"},{"doc":"database/schema","title":"FieldType","content":"pub type FieldType {\n  Integer\n  String\n}\n The type of a field in a table. Not really used for anything yet.\nInteger\n\n\nString\n\n\nSynonyms:\ndatabase/schema.FieldType\ndatabase/schema FieldType","url":"database/schema.html#FieldType"},{"doc":"database/schema","title":"Schema","content":"pub type Schema(a) {\n  Schema(\n    table: String,\n    primary_key: String,\n    fields: List(Field),\n    decoder: dynamic.Decoder(a),\n  )\n}\n The schema of a table. The table name, primary key,\n and fields are used to generate SQL queries.\n The decoder is used to decode the results of a query\n into a Gleam value.\n \n ## Examples\n \n \n pub type Note {\n  Note(id: Int, title: String, content: String)\n }\n\n pub fn schema() {\n  Schema(\n    table: &quot;notes&quot;,\n    primary_key: &quot;id&quot;,\n    fields: [\n      Field(&quot;id&quot;, schema.Integer),\n      Field(&quot;title&quot;, schema.String),\n      Field(&quot;content&quot;, schema.String),\n    ],\n    decoder: dynamic.decode3(\n      Note,\n      dynamic.element(0, dynamic.int),\n      dynamic.element(1, dynamic.string),\n      dynamic.element(2, dynamic.string),\n    ),\n  )\n }\n \n \nSchema(\n  table: String,\n  primary_key: String,\n  fields: List(Field),\n  decoder: dynamic.Decoder(a),\n)\n\n\nSynonyms:\ndatabase/schema.Schema\ndatabase/schema Schema","url":"database/schema.html#Schema"},{"doc":"database/schema","title":"database/schema","content":" The schema module defines the schema of a table.\n It is used to generate SQL queries and to decode\n the results of a query into a Gleam value.","url":"database/schema.html"},{"doc":"database/query","title":"Query","content":"pub type Query(a) {\n  Query(\n    from: Schema(a),\n    select: List(String),\n    where: List(String),\n    bindings: List(pgo.Value),\n  )\n}\n A query is a struct that contains the schema to query from, the fields to\n select, the where clause, and the bindings for the query.\n \n Normally you won&#39;t interact with this struct directly, instead you&#39;ll use\n the functions below to build up a query and then pass it to the associated\n functions to get the SQL string. These are already wrapped in the top level\n `database` module.\nQuery(\n  from: Schema(a),\n  select: List(String),\n  where: List(String),\n  bindings: List(pgo.Value),\n)\n\n\nSynonyms:\ndatabase/query.Query\ndatabase/query Query","url":"database/query.html#Query"},{"doc":"database/query","title":"Where","content":"pub type Where =\n  List(#(String, List(pgo.Value)))\n A where clause is a list of tuples where the first element is the field\n name and the second is the value to bind to that field. It will\n automatically generate the correct number of placeholders for the values\n and append them to the bindings list for PGO.\n\nSynonyms:\ndatabase/query.Where\ndatabase/query Where","url":"database/query.html#Where"},{"doc":"database/query","title":"build","content":"pub fn build(query: Query(a)) -&gt; String\n Builds the SQL string for the query. This is the same as `SELECT ... FROM\n ... WHERE ...` in SQL.\nSynonyms:\ndatabase/query.build\ndatabase/query build","url":"database/query.html#build"},{"doc":"database/query","title":"delete","content":"pub fn delete(query: Query(a)) -&gt; String\n Builds the SQL string for a delete query. This is the same as `DELETE FROM\n ... WHERE ...` in SQL. It will return the deleted rows.\nSynonyms:\ndatabase/query.delete\ndatabase/query delete","url":"database/query.html#delete"},{"doc":"database/query","title":"from","content":"pub fn from(schema: Schema(a)) -&gt; Query(a)\n Create a new query from a schema. This is the starting point for building\n a query and the schema&#39;s decoder is also used as the returned value.\nSynonyms:\ndatabase/query.from\ndatabase/query from","url":"database/query.html#from"},{"doc":"database/query","title":"insert","content":"pub fn insert(schema: Schema(a)) -&gt; String\n Builds the SQL string for an insert query. This is the same as `INSERT INTO\n ... (field1, field2, ...) VALUES (value1, value2, ...)` in SQL. It will ignore\n the primary key field in the schema but may supporrt that in the future.\nSynonyms:\ndatabase/query.insert\ndatabase/query insert","url":"database/query.html#insert"},{"doc":"database/query","title":"select","content":"pub fn select(query: Query(a), fields: List(String)) -&gt; Query(a)\n Adds fields to the select clause of the query. This is the same as\n `SELECT field1, field2, ...` in SQL.\nSynonyms:\ndatabase/query.select\ndatabase/query select","url":"database/query.html#select"},{"doc":"database/query","title":"update","content":"pub fn update(query: Query(a), fields: List(#(String, Value))) -&gt; String\n Builds the SQL string for an update query. This is the same as `UPDATE ...\n SET field1 = value1, field2 = value2, ...` in SQL. It will return\n the updated rows.\nSynonyms:\ndatabase/query.update\ndatabase/query update","url":"database/query.html#update"},{"doc":"database/query","title":"where","content":"pub fn where(query: Query(a), bindings: List(\n    #(String, List(Value)),\n  )) -&gt; Query(a)\n Adds a where clause to the query. This is the same as `WHERE field = value`\n in SQL. The values will be appended to the bindings list for PGO.\nSynonyms:\ndatabase/query.where\ndatabase/query where","url":"database/query.html#where"},{"doc":"database/query","title":"database/query","content":" A query builder for Postgres, it&#39;s not fully built out yet and \n currently only performs the most basic queries.","url":"database/query.html"},{"doc":"database","title":"all","content":"pub fn all(q: Query(a), db: Connection) -&gt; Result(\n  List(a),\n  QueryError,\n)\n Select all rows from a table.\n \n ## Examples\n \n \n schema\n |&gt; from()\n |&gt; select([&quot;id&quot;, &quot;name&quot;])\n |&gt; database.all(db)\n \n schema\n |&gt; from()\n |&gt; select([&quot;*&quot;])\n |&gt; database.all(db)\n \nSynonyms:\ndatabase.all\ndatabase all","url":"database.html#all"},{"doc":"database","title":"delete","content":"pub fn delete(query: Query(a), db: Connection) -&gt; Result(\n  a,\n  QueryError,\n)\n Delete a record from a table. Right now it will only\n return the first deleted record but could be updated\n to return more than one.\n \n ## Examples\n \n \n schema()\n |&gt; from()\n |&gt; where([#(&quot;id = $1&quot;, [pgo.int(id)])])\n |&gt; database.delete(db)\n \nSynonyms:\ndatabase.delete\ndatabase delete","url":"database.html#delete"},{"doc":"database","title":"insert","content":"pub fn insert(schema: Schema(a), data: List(Value), db: Connection) -&gt; Result(\n  a,\n  QueryError,\n)\n Insert a record into a table.\n \n ## Examples\n \n \n database.insert(\n   schema(),\n   [pgo.text(note.title), pgo.text(note.content)],\n   db,\n )\n \nSynonyms:\ndatabase.insert\ndatabase insert","url":"database.html#insert"},{"doc":"database","title":"one","content":"pub fn one(q: Query(a), db: Connection) -&gt; Option(a)\n Select a single record from a table. If there&#39;s more \n than one row returned this will only return the first.\n \n ## Examples\n \n \n schema()\n |&gt; from()\n |&gt; select([&quot;*&quot;])\n |&gt; where([#(&quot;id = $1&quot;, [pgo.int(id)])])\n |&gt; database.one(db)\n \n schema()\n |&gt; from()\n |&gt; select([&quot;id&quot;])\n |&gt; where([#(&quot;title ilike &#39;%$1%&#39;&quot;, [pgo.text(title)])])\n |&gt; database.one(db)\n \nSynonyms:\ndatabase.one\ndatabase one","url":"database.html#one"},{"doc":"database","title":"update","content":"pub fn update(query: Query(a), data: List(#(String, Value)), db: Connection) -&gt; Result(\n  a,\n  QueryError,\n)\n Update one or more records in a table. Right now\n it will only return the first updated record but\n could be updated to return more than one.\n \n ## Examples\n \n \n schema()\n |&gt; from()\n |&gt; where([#(&quot;id = $1&quot;, [pgo.int(id)])])\n |&gt; database.update(\n   [\n     #(&quot;title&quot;, pgo.text(note.title)),\n     #(&quot;content&quot;, pgo.text(note.content)),\n   ],\n   db,\n )\n \nSynonyms:\ndatabase.update\ndatabase update","url":"database.html#update"},{"doc":"database","title":"database","content":" This is the main entry point for interacting with pgo dbs.\n It does things like selecting all rows, single records, inserting, updating, and deleting.","url":"database.html"}]);